# $Id: factory_attr.py 2588 2009-07-28 11:03:09Z mmamonski $
#
# vim: set ts=4 sw=4 et:

#
# QosCosGrid Computing
# Copyright (C) 2008-2011 Poznan Supercomputing and Networking Center
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>
#

try: 
  from qcg.core import *
  from qcg.comp import *
except ImportError:
  class Module:
    pass
  def signal_connect(a1,a2):
    pass

from commands import getstatusoutput
from xml.dom.minidom import Document
import os
import re

class ModulesInfoModule(Module):
  
  def __init__(self, *unused):
    signal_connect("smc_factory_attributes", self.signal_handler)
    
    self.__QCGCompFactoryNS = "http://schemas.qoscosgrid.org/comp/2011/04/factory"
 
  def signal_handler(self, signal, local_resource_manager_type, not_used):
    
    command_output = getstatusoutput(". /etc/profile && module  avail")

    doc = Document()    
    modulesEl = doc.createElementNS(self.__QCGCompFactoryNS, "Modules")    
    modulesEl.setAttribute("xmlns",self.__QCGCompFactoryNS)
    doc.appendChild(modulesEl)
    
    for token in command_output[1].split():
      if token.startswith("-") or token.startswith("/"):
        continue
      if token.find("/") == -1:
        continue

      module_name = token.rsplit("/", 1)[0]
      module_version = token.rsplit("/", 1)[1]
      
      moduleEl = doc.createElement("Module")
      moduleEl.setAttribute("name", module_name)
      moduleEl.setAttribute("version", module_version)
      modulesEl.appendChild(moduleEl)
    
    
    result = doc.toxml().replace("<?xml version=\"1.0\" ?>", "")
    doc.unlink()
    return result
